// Beginn der Webseite zur Garagentorsteuerung.
<html>

// Im Abschnitt "head" wird der Titel des Browserfensters gesetzt.
        <head>
                <title>Garagentor Steuerung</title>
        </head>

// Im Abschnitt "body" wird die eigentliche Webseite definiert.
        <body>

// Setzen der Schriftart.
                <font face="Arial">

// Erzeugen eines Formulars mit einem Button.
                <form method="post" action="index.php">

// Größe des Formulars. Dieses habe ich an die Auflösung des Browsers auf meinem Smartphone angepasst. Hier kann jeder selber ein wenig experimentieren.
                <fieldset style="height: 1200px; width: 805px;">

// Überschrift des Formulars, sowie die Schriftgröße, Schriftgestaltung und die Ausrichtung des Textes.
                <legend style="font-size: 72px;text-align: center; font-weight: bold;">Garagentor Steuerung</legend><br><br><br>

// Beschriftung des Buttons, sowie die Schriftgröße, Schriftgestaltung und die Ausrichtung des Textes. Das Auslösen des Buttons wird in der Variable "Tor" gespeichert.
                <input style="font-size: 76px; font-weight: bold; height: 800px; width: 800px;" type="submit" value="Torfahrt auslösen" name="Tor"><br><br><br><br>

// Hier wechsle ich von der HTML Programmierung zu PHP um die GPIO abfragen bzw. setzen zu können. 
                <?php

// Die verschiedenen Kommandos zum abfragen bzw. setzen der GPIO Ports werden in Variablen gespeichert.
// Das nächste Kommando setzt den Mode des GPIO Ports 17 auf Output um den Impulstaster zum Auslösen einer Torfahrt zu simulieren.
                        $setmode17 = shell_exec("/usr/local/bin/gpio -g mode 17 out");

// Dieses Kommando setzt den Mode des GPIO Ports 22 auf Input um den Schaltzustand des 24V Relais zum Erkennen eines offenen Tores abzufragen.
                        $setmode22 = shell_exec("/usr/local/bin/gpio -g mode 22 in");

// Hier wird der Zustand des GPIO Port 22 abgefragt und in der Variable "readmode22" gespeichert (siehe weiter unten).
                        $readmode22 = shell_exec("/usr/local/bin/gpio -g read 22");

// Die URL der Webseite wird in der Variablen "url" gespeichert, damit diese später automatisch neu geladen werden kann.
                        $url=$_SERVER['REQUEST_URI'];

// Wenn das Garagentor geschlossen ist, wird die „Tor-Zu Erkennung“ betätigt. Damit liegen die 24V an und
// das entsprechende Relais ist angezogen. Der Arbeitskontakt wird geöffnet und die 3,3V vom Pin 2 an den
// GPIO Port 22 werden unterbrochen. Damit ist der Zustand des GPIO Ports 0.
// Es wird auf der Webseite angezeigt, dass das Garagentor geschlossen ist. 
// Die Webseite wird bei geschlossenem Tor alle 10 Sekunden automatisch neu geladen.

                        if($readmode22 == 0){
                                echo '<p style="width: 805px; text-align: center;color: green;font-size: 72px;font-weight: bold;font-family: arial; " >Das Tor ist zu</p>';
                                echo "<br>";
                                header("Refresh: 10; URL=$url");
                        }

// Wird das Garagentor geöffnet fallen die 24V der „Tor-Zu Erkennung“ weg und das Relais schließt den
// Arbeitskontakt. Es werden die 3,3V vom Pin 2 an den GPIO Port 22 weitergeben und der Zustand
// des GPIO Ports ist 1. Auf der Webseite wird angezeigt, dass das Garagentor geöffnet ist. Die Webseite
// wird bei geöffnetem Tor alle 2 Sekunden automatisch neu geladen.
                        if($readmode22 == 1){
                                echo '<p style="width: 805px; text-align: center;color: red;font-size: 72px;font-weight: bold;font-family: arial; " >Das Tor ist offen</p>';
                                echo "<br>";
                                header("Refresh: 2; URL=$url");
                        }

// Wurde der Button auf der Webseite geklickt, simulieren die folgenden Kommandos das drücken des Impulstasters.
// Dazu wird der GPIO Port 17 mit 3,3V geschaltet. Das 5V Relais Modul zieht an.
// Um dem Garagentor die Möglichkeit zu geben den Tastendruck zu erkennen, bleibt das 5V Relais Modul 1 Sekunde angezogen.
// Danach wird der GPIO Port 17 wieder auf 0V zurückgesetzt und das 5V Relais Modul fällt ab. Damit ist der Tastendruck beendet.
// Da eine Torfahrt ausgelöst wurde, wird die Webseite alle 2 Sekunden automatisch neu geladen.
                        if(isset($_POST['Tor'])){
                                $gpio_off = shell_exec("/usr/local/bin/gpio -g write 17 1");
                                sleep(1);
                                $gpio_off = shell_exec("/usr/local/bin/gpio -g write 17 0");
                                echo "<br>";
                                header("Refresh: 2; URL=$url");

                        }

// Der PHP Teil der Webseite wird beendet.
				?>
				
        </body>

// Das ist das Ende der Webseite
</html>

